STOP 
**** Uses client groups identified in volunteering opportunities registered on Milo
**** Export report Stirling data Extract Client Groups from public reports in Milo
**** save as client groups.xlsx in wp1/MILO

**** import volunteering data
clear
import excel ///
"$wp1\MILO\client groups.xlsx", ///
sheet("client groups") firstrow case(lower)
ren organisationorganisationid orgid
ren organisationorganisationname orgname
bysort orgid clientgroup: gen opps=_N
compress
save "$wp1\MILO\clientgroups.dta", ///
replace
use "$wp1\MILO\milo_merged", clear 
capture drop _merge
merge m:m orgid using "$wp1\MILO\clientgroups", update 

*** Orgs have several volunteering opps with different client groups - need to pick 1

*** save file with 1 row per orgs per client group, with number of opportunities for that group
codebook orgid if _merge==3 & icnpo_comb==.
drop if _merge<3
drop if icnpo_comb!=.
drop if orgid==""
tab clientgroup
drop if clientgroup=="Miscellaneous"
capture drop _freq
contract orgname orgid icnpo_comb icnpo clientgroup opps
drop _freq 
bysort orgname: gen clients=_N
save "$wp1\MILO\milo_clients", replace

***** relate client group to icnpo codes
replace icnpo_comb=5200 if clientgroup=="Animals"
replace icnpo_comb=4300 if clientgroup=="Anti poverty work"
replace icnpo_comb=1100 if clientgroup=="Arts (music /drama / crafts)"
replace icnpo_comb=4170 if clientgroup=="Carers"
replace icnpo_comb=4110 if clientgroup=="Children"
replace icnpo_comb=6000 if clientgroup=="Crime / Safety"
replace icnpo_comb=4200 if clientgroup=="Disaster / emergencies"
replace icnpo_comb=3410 if clientgroup=="Drugs / Alcohol Issues"
replace icnpo_comb=2300 if clientgroup=="Education / literacy"
replace icnpo_comb=4150 if clientgroup=="Elderly"
replace icnpo_comb=5100 if clientgroup=="Environment"
replace icnpo_comb=7110 if clientgroup=="Ethnic Minorities"
replace icnpo_comb=4110 if clientgroup=="Families"
replace icnpo_comb=7120 if clientgroup=="Gender / Sexuality"
replace icnpo_comb=3400 if clientgroup=="Health/Hospitals/Hospices"
replace icnpo_comb=4220 if clientgroup=="Homeless / Housing"
replace icnpo_comb=7100 if clientgroup=="Human / Civil rights/ Justice"
replace icnpo_comb=4140 if clientgroup=="Learning Disabilities"
replace icnpo_comb=2300 if clientgroup=="Literacy Needs"
replace icnpo_comb=6100 if clientgroup=="Local Authority"
replace icnpo_comb=6100 if clientgroup=="Local Community"
replace icnpo_comb=4300 if clientgroup=="Low Income Households"
replace icnpo_comb=4100 if clientgroup=="Mens groups"
replace icnpo_comb=3300 if clientgroup=="Mental Health"
replace icnpo_comb=1100 if clientgroup=="Museums / galleries / heritage"
replace icnpo_comb=7230 if clientgroup=="Offenders And Ex Offenders"
replace icnpo_comb=4150 if clientgroup=="Older People"
replace icnpo_comb=9100 if clientgroup=="Overseas aid / developing world"
replace icnpo_comb=4110 if clientgroup=="Parents"
replace icnpo_comb=3400 if clientgroup=="People With Ill Health"
replace icnpo_comb=4140 if clientgroup=="Physical Disability"
replace icnpo_comb=4180 if clientgroup=="Refugees / Asylum seekers"
replace icnpo_comb=10100 if clientgroup=="Religion / faith"
replace icnpo_comb=4140 if clientgroup=="Sensory Impairment"
replace icnpo_comb=1200 if clientgroup=="Sport / Outdoor activities"
replace icnpo_comb=6300 if clientgroup=="Tackling Unemployment"
replace icnpo_comb=6300 if clientgroup=="Unemployed"
replace icnpo_comb=4100 if clientgroup=="Victims Of Crime"
replace icnpo_comb=4160 if clientgroup=="Womens Groups"
replace icnpo_comb=4130 if clientgroup=="Young People"

replace icnpo_comb=7200 if regexm(orgname,"police") == 1

tab icnpo_comb, missing

*** check any client groups not already acccounted for
browse clientgroup if icnpo_comb==.

drop if icnpo_comb==.

capture drop _freq

contract orgname orgid icnpo_comb opps

**** see how many different icnpo codes have been used per organisation
bysort orgname: gen codes=_N
save, replace

tab codes

*** if one icnpo code has more volunteering opps than others, choose that
bysort orgid: egen maxopps=max(opps)
drop if codes>1 & opps<maxopps
drop codes
bysort orgname: gen codes=_N
tab codes
**browse if codes>1

**** summarise some of the icnpo codes
replace icnpo_comb=4100 if codes>1 & icnpo_comb>3999 & icnpo_comb<5000
drop _freq
contract orgname orgid icnpo_comb
bysort orgname: gen codes=_N
tab _freq codes
bysort orgid: egen maxfreq=max(_freq)
drop if codes>1 & _freq<maxfreq
tab codes

*** ignore orgs where more than one icnpo code applies
drop if codes>1
save, replace

use "$wp1\MILO\milo_merged", clear 

**** start from here if no new client data was downloaded
capture drop _merge
merge m:m orgid using "$wp1\MILO\milo_clients", ///
keepusing(icnpo_comb) update

tab icnpo_comb, missing

replace icnpo_comb_how="5 client group" if icnpo_comb!=. & icnpo_comb_how==""
replace icnpo_comb=4100 if icnpo_comb==4000
replace icnpo_comb=5200 if icnpo_comb==5000
replace icnpo_comb=6100 if icnpo_comb==6000
save, replace
