
use "$wp1\MILO\milo_merged.dta", clear

keep combname ///
list ///
orgid ///
citycounty ///
aims ///
mainactivities ///
par_oname ///
par_aims ///
par_mainacts ///
par_regchar ///
parentorg ///
branchoflargerorganisation ///
largerorganisationdetails ///
charitynumber ///
charityname ///
registereddate ///
knownas ///
charitystatus ///
constitutionalform ///
geographicalspread ///
mainoperatinglocation ///
purposes ///
beneficiaries ///
activities ///
objectives ///
principalofficetrusteesaddres ///
postcode ///
website ///
mostrecentyearincome ///
mostrecentyearexpenditure ///
yearend ///
parentcharityname ///
parentcharitynumber ///
parentcharitycountryofregist ///
oscrhow ///
designatedreligiousbody ///
icnpo_comb ///
icnpo_comb_how ///
orgtypecl ///
ownertsi ///
voluntary ///
LAD15CD ///
LAD15NM ///
GOR10CD ///
GOR10NM ///
ru11ind ///
simd2012_sc_quintile ///
simd2012_sc_decile ///
osward ///
oshlthau ///
teclec ///
lsoa11

ren orgid milo_orgid
ren citycounty milo_citycounty
ren aims milo_aims
ren mainactivities milo_mainactivities
ren par_oname milo_par_oname
ren par_aims milo_par_aims
ren par_mainacts milo_par_mainacts
ren par_regchar milo_par_regchar
ren branchoflargerorganisation milo_branchoflarger
ren largerorganisationdetails milo_largerorg
ren parentorg milo_par_orgid
ren charitynumber oscr_charitynumber
ren charityname oscr_charityname
ren registereddate oscr_registereddate
ren knownas oscr_knownas
ren charitystatus oscr_charitystatus
ren constitutionalform oscr_constitutionalform
ren geographicalspread oscr_geographicalspread
ren mainoperatinglocation oscr_mainoperatinglocation
ren purposes oscr_purposes
ren beneficiaries oscr_beneficiaries
ren activities oscr_activities
ren objectives oscr_objectives
ren principalofficetrusteesaddres oscr_address
ren postcode oscr_postcode
ren website oscr_website
ren mostrecentyearincome oscr_lastyearincome
ren mostrecentyearexpenditure oscr_lastyearexpenditure
ren yearend oscr_yearend
ren parentcharityname oscr_parentcharityname
ren parentcharitynumber oscr_parentcharitynumber
ren parentcharitycountryofregist oscr_parentcountry
ren designatedreligiousbody oscr_designatedreligiousbody
ren orgtypecl milo_orgtypecl
ren oscrhow match_how
ren ownertsi milo_ownertsi
ren LAD15CD geog_LAD15CD
ren LAD15NM geog_LAD15NM
ren GOR10CD geog_GOR10CD
ren GOR10NM geog_GOR10NM
ren ru11ind geog_ru11ind
ren simd2012_sc_quintile geog_simd2012_sc_quintile
ren simd2012_sc_decile geog_simd2012_sc_decile
ren osward geog_osward
ren oshlthau geog_oshlthau
ren teclec geog_teclec
ren lsoa11 geog_lsoa11

order combname lists match_how icnpo_comb icnpo_comb_how voluntary milo_* ///
oscr_* geog_*


***export excel using "$wp1\Deposit\depositfile.xls", firstrow(variables) replace
export delimited using "$wp1\Deposit\civil_society_organisations_in_Scotland.csv", quote replace
save "$wp1\Deposit\Civil_society_organisations_in_Scotland.dta", replace

********************************************************************
***** update documentation
********************************************************************

use "$wp1\MILO\milo_merged.dta", clear

**** missing postcode for voluntary orgs on Milo
tab geog_LAD15NM if voluntary==1 * lists!=2

***** registered charity nos
use "C:\Users\ob3\Dropbox\scottishcsdp\wp1-datacuration\milo\milo_merged.dta", clear
** how many have reg char nos
codebook regcharno if voluntary==1 & lists!=2
* how many matched
codebook regcharcln if voluntary==1 & lists!=2

**** how many milo matched to oscr
tab lists if voluntary==1 & lists!=2

*** how many unique charities on Milo
codebook charitynumber if lists!=2

** how milo & oscr were matched
tab oscrhow if voluntary==1 & lists!=2

codebook charitynumber if lists!=1 & oscrhow=="1 regno" 
codebook charitynumber if lists!=1 & oscrhow=="2 name & pc" 
codebook charitynumber if lists!=1 & oscrhow=="3 name only" 
codebook charitynumber if lists!=1 & oscrhow=="4 probable" 
codebook charitynumber if lists!=1 & oscrhow=="6 OSCR only" 

** how milo & oscr were icnpo coded
tab icnpo_comb_how if voluntary==1 & lists!=2, missing

codebook charitynumber if lists!=1 & icnpo_comb_how =="1 orgname" 
codebook charitynumber if lists!=1 & substr(icnpo_comb_how,1,1)=="2" 
codebook charitynumber if lists!=1 & substr(icnpo_comb_how,1,1)=="3" 
codebook charitynumber if lists!=1 & substr(icnpo_comb_how,1,1)=="4"
codebook charitynumber if lists!=1 & substr(icnpo_comb_how,1,1)=="5"
codebook charitynumber if lists!=1 & substr(icnpo_comb_how,1,1)=="6"
codebook charitynumber if lists!=1 & substr(icnpo_comb_how,1,1)==""

** icnpo coding vol orgs on Milo

tab icnpo_comb if lists!=2 & voluntary==1

*** icnpo coding OSCR orgs
unique charitynumber if lists!=1, by(icnpo_comb) gen(_unique)
drop _unique

*** icnpo coding all vol orgs

tab icnpo_comb if voluntary==1

tab icnpo_comb if voluntary==.

