STOP 
*** this file will identify registered charities not already matched to Milo via ///
*** registered charity numbers and attempt deterministic then probabilistic matching. ///
*** Finally a combined dataset is created, ready to have ICNPO coding added.
*** The probabilistic matching required the installation of the Stata package ///
*** reclink2, see http://www-personal.umich.edu/~nwasi/Wasi_Flaaen_StataRecordLinkageUtilities_20140919.pdf


**** First identify charities not already found on Milo
use "$wp1\oscr\oscrpublic.dta", clear
gen regcharcln=charitynumber
merge 1:m regcharcln using ///
"$wp1\MILO\milo_aims.dta" ///
, keepusing(orgid orgname)
drop if _merge>1
drop _merge orgid orgname
save "$wp1\oscr\oscrnotmilo.dta", replace 

*** try to match on orgname
*** first create clean orgname for Milo
use "$wp1\MILO\milo_aims.dta", clear

**** create versions of Gaelic orgnames minus accents
replace orgname ="Coisir Ghoidhlig Thaigh An Uill Taynuilt Gaelic Choir" if orgid=="00124000008niBq"
replace orgname ="East Kilbride Arts Anyone can sing Group" if orgid=="00124000008nYfp"
replace orgname ="Scottish Country Dance Club, Dalavich" if orgid=="00124000008nfnC"
replace orgname ="Bell Baxter High School Fund Fair Fund" if orgid=="00124000008nchR"
replace orgname ="Alzheimer Scotland This is me passport" if orgid=="00124000008ncwm"
replace orgname ="new start bi-polar support group dumfries" if orgid=="00124000008ncDD"
replace orgname ="Gourock Baby & Toddler Playgroup ?TinyTots" if orgid=="00124000008ne5l"
replace orgname ="Mount Kirk Toddlers / Forget-Me-Not" if orgid=="00124000008ndjm"
replace orgname ="Cafe de Youth" if orgid=="00124000008nhfb"
replace orgname ="Forres Youth Cafe" if orgid=="00124000008ngYA"
replace orgname ="Jedburgh Youth Cafe Association - CEASED" if orgid=="00124000008ngl0"
replace orgname ="Tain Youth Cafe" if orgid=="00124000008nh54"
replace orgname ="new start Youth Arts" if orgid=="00124000008neGK"
replace orgname ="Oban Youth Cafe" if orgid=="00124000008nZlc"
replace orgname ="New start - autism network SE" if orgid=="00124000008neD9"
replace orgname ="Heaven and Earth Cafe" if orgid=="00124000008ngS5"
replace orgname ="new start Moffat Community Woodlands" if orgid=="00124000008neGB"
replace orgname ="new start animal sanctuary" if orgid=="00124000008ncap"
replace orgname ="Kennoway Community Centre - Youth Cafe" if orgid=="00124000008ndI4"
replace orgname ="New Start Social Enterprise Joe Gough" if orgid=="00124000008neNx"
replace orgname ="Lochee Parish Church Drop Inn Community Cafe" if orgid=="00124000008nZAs"
replace orgname ="new start CIC Blue Skies Venture" if orgid=="00124000008ndxS"
replace orgname ="New Start Cash for Clothes Charity Shop" if orgid=="00124000008ndE2"
replace orgname ="Aberfeldy Community Cafe" if orgid=="00124000008nXF8"
replace orgname ="Ageing Well Changing Lifestyles" if orgid=="00124000008nek4"
replace orgname ="Bay Tree Community Cafe Project" if orgid=="00124000008nbcb"
replace orgname ="Calligraphy Group, Lochgilphead" if orgid=="00124000008nfb3"
replace orgname ="Cinnamon Cafe" if orgid=="00124000008nayf"
replace orgname ="Feis Oigridh Ile is Dhiura" if orgid=="00124000008nfdz"
replace orgname ="Fife Polish Association MOST" if orgid=="00124000008ndMS"
replace orgname ="Friends Of What View Ltd" if orgid=="00124000008nfP7"
replace orgname ="Glenrothes Information Cafe" if orgid=="00124000008ndDH"
replace orgname ="Green Tree Community Cafe" if orgid=="00124000008nfer"
replace orgname ="Harbour Howff Cafe" if orgid=="00124000008ndMq"
replace orgname ="Kincardine Community Cafe" if orgid=="00124000008ndSk"
replace orgname ="Leven Information Cafe" if orgid=="00124000008ndDM"
replace orgname ="Mobile Crèche" if orgid=="00124000008neL4"
replace orgname ="Strathbrock Partnership Cafe / Cafe Mistura" if orgid=="00124000008niFb"
replace orgname ="new start Care Solution Move to CIC" if orgid=="00124000008ndt6"
replace orgname ="new start Glenluce Skate Park" if orgid=="00124000008ndiu"
replace orgname ="Cafe Refresh" if orgid=="00124000008neQK"
replace orgname ="Defence of Britain Project, North Clyde Group" if orgid=="00124000008nhoA"
replace orgname ="East Pollokshields Mobile Creche" if orgid=="00124000008ngJT"
replace orgname ="Mactaggart Community Cyber Cafe" if orgid=="00124000008nhzC"
replace orgname ="Asociacion San Mateo" if orgid=="00124000008ncA7"
replace orgname ="Curam Thiriodh" if orgid=="00124000008nfYf"
replace orgname ="Feis Phaislig" if orgid=="00124000008neHE"
replace orgname ="Mobile Creche" if orgid=="00124000008neL4"
replace orgname ="Bord na Gaidhlig" if orgid=="0012400000tszud"
replace orgname ="Dick's Hill Creche Limited" if orgid=="00124000008nZHc"

capture drop orgname_lower
gen orgname_lower=lower(orgname)
capture drop orglowcl

**** create lowercase version of orgname with all non-standard characters removed
gen orglowcl = subinstr(orgname_lower,"!","",.)

replace orglowcl = subinstr(orglowcl,"#","",.)
replace orglowcl = subinstr(orglowcl,"%","",.)
replace orglowcl = subinstr(orglowcl,"&","",.)
replace orglowcl = subinstr(orglowcl,"","",.)
replace orglowcl = subinstr(orglowcl,"(","",.)
replace orglowcl = subinstr(orglowcl,")","",.)
replace orglowcl = subinstr(orglowcl,"*","",.)
replace orglowcl = subinstr(orglowcl,"+","",.)
replace orglowcl = subinstr(orglowcl,",","",.)
replace orglowcl = subinstr(orglowcl,"-","",.)
replace orglowcl = subinstr(orglowcl,".","",.)
replace orglowcl = subinstr(orglowcl,"/","",.)
replace orglowcl = subinstr(orglowcl,":","",.)
replace orglowcl = subinstr(orglowcl,"=","",.)
replace orglowcl = subinstr(orglowcl,"?","",.)
replace orglowcl = subinstr(orglowcl,"@","",.)
replace orglowcl = subinstr(orglowcl,"[","",.)
replace orglowcl = subinstr(orglowcl,"\","",.)
replace orglowcl = subinstr(orglowcl,"]","",.)
replace orglowcl = subinstr(orglowcl,"_","",.)
replace orglowcl = subinstr(orglowcl,"`","",.)
replace orglowcl = subinstr(orglowcl,"'","",.)
replace orglowcl = subinstr(orglowcl,"{","",.)
replace orglowcl = subinstr(orglowcl,"}","",.)
replace orglowcl = subinstr(orglowcl,"|","",.)
replace orglowcl = subinstr(orglowcl,"","",.)
replace orglowcl= subinstr(orglowcl,char(34),"",.)
replace orglowcl= subinstr(orglowcl,char(169),"e",.)
replace orglowcl= subinstr(orglowcl,char(178),"o",.)
replace orglowcl= subinstr(orglowcl,char(195),"",.)

charlist orglowcl
replace orglowcl=strtrim(orglowcl)

save, replace

**** search for orgnames which still contain non-standard characters
capture drop orgcheck
gen orgcheck=orglowcl
replace orgcheck = subinstr(orgcheck,"1","",.)
replace orgcheck = subinstr(orgcheck,"2","",.)
replace orgcheck = subinstr(orgcheck,"3","",.)
replace orgcheck = subinstr(orgcheck,"4","",.)
replace orgcheck = subinstr(orgcheck,"5","",.)
replace orgcheck = subinstr(orgcheck,"6","",.)
replace orgcheck = subinstr(orgcheck,"7","",.)
replace orgcheck = subinstr(orgcheck,"8","",.)
replace orgcheck = subinstr(orgcheck,"9","",.)
replace orgcheck = subinstr(orgcheck,"0","",.)
replace orgcheck = subinstr(orgcheck,"a","",.)
replace orgcheck = subinstr(orgcheck,"b","",.)
replace orgcheck = subinstr(orgcheck,"c","",.)
replace orgcheck = subinstr(orgcheck,"d","",.)
replace orgcheck = subinstr(orgcheck,"e","",.)
replace orgcheck = subinstr(orgcheck,"f","",.)
replace orgcheck = subinstr(orgcheck,"g","",.)
replace orgcheck = subinstr(orgcheck,"h","",.)
replace orgcheck = subinstr(orgcheck,"i","",.)
replace orgcheck = subinstr(orgcheck,"j","",.)
replace orgcheck = subinstr(orgcheck,"k","",.)
replace orgcheck = subinstr(orgcheck,"l","",.)
replace orgcheck = subinstr(orgcheck,"m","",.)
replace orgcheck = subinstr(orgcheck,"n","",.)
replace orgcheck = subinstr(orgcheck,"o","",.)
replace orgcheck = subinstr(orgcheck,"p","",.)
replace orgcheck = subinstr(orgcheck,"q","",.)
replace orgcheck = subinstr(orgcheck,"r","",.)
replace orgcheck = subinstr(orgcheck,"s","",.)
replace orgcheck = subinstr(orgcheck,"t","",.)
replace orgcheck = subinstr(orgcheck,"y","",.)
replace orgcheck = subinstr(orgcheck,"u","",.)
replace orgcheck = subinstr(orgcheck,"v","",.)
replace orgcheck = subinstr(orgcheck,"w","",.)
replace orgcheck = subinstr(orgcheck,"x","",.)
replace orgcheck = subinstr(orgcheck,"y","",.)
replace orgcheck = subinstr(orgcheck,"z","",.)
replace orgcheck = subinstr(orgcheck," ","",.)

charlist orgcheck
return list
browse orgid orgname orgcheck if orgcheck!=""
drop orgcheck 
save, replace

*** create clean charity name for oscr

use "$wp1\oscr\oscrnotmilo.dta", clear 

replace charityname ="St Machar's Ranfurly Church, Church of Scotland, Bridge of Weir" if charitynumber=="SC003766"
replace charityname ="Va'ad L'Ma'an Habonim" if charitynumber=="SC005290"
replace charityname ="Falkirk Larbert Congregation of Jehovah's Witnesses" if charitynumber=="SC007688"
replace charityname ="Dreghorn Pre School and Creche" if charitynumber=="SC013346"
replace charityname ="Barrhead: St Andrew's Parish Church of Scotland" if charitynumber=="SC015730"
replace charityname ="St Christopher's Priesthill & Nitshill Church of Scotland, Glasgow" if charitynumber=="SC015858"
replace charityname ="Lochee Boy's & Girls Club" if charitynumber=="SC016531"
replace charityname ="St Columba's Free Church of Scotland" if charitynumber=="SC016551"
replace charityname ="North East Scotland College Students' Association" if charitynumber=="SC021540"
replace charityname ="Edinburgh City Youth Cafe" if charitynumber=="SC022146"
replace charityname ="Royal Scottish Country Dance Society Dunfermline Local Association" if charitynumber=="SC027501"
replace charityname ="Edinburgh College Students' Association" if charitynumber=="SC028544"
replace charityname ="Richmond Cafe Project" if charitynumber=="SC031536"
replace charityname ="Den Youth Cafe" if charitynumber=="SC034129"
replace charityname ="Forres Youth Cafe Limited" if charitynumber=="SC034187"
replace charityname ="Coisir Dhun Eideann" if charitynumber=="SC035141"
replace charityname ="Fortrose Avoch And Rosemarkie Youth Cafe" if charitynumber=="SC036151"
replace charityname ="Adventist Development and Relief Agency" if charitynumber=="SC037726"
replace charityname ="Charity for St Joseph's Missionary Society (British Region)" if charitynumber=="SC039809"
replace charityname ="Urras Baile Fhlodaigearraidh" if charitynumber=="SC040726"
replace charityname ="The Dochas Education Trust" if charitynumber=="SC040900"
replace charityname ="Auchtermuchty Seniors' Club" if charitynumber=="SC041319"
replace charityname ="A&M Scotlan Achieve More" if charitynumber=="SC041463"
replace charityname ="Agape Ministries Limited" if charitynumber=="SC042332"
replace charityname ="Feis Pheislig" if charitynumber=="SC045342"
replace charityname ="iGaidhlig" if charitynumber=="SC045374"
replace charityname ="Curam Thiriodh" if charitynumber=="SC042742"

replace charityname = "Lothian Veterans Centre" if charitynumber=="SC040690"
replace charityname = "Maryhill Mobile Childrens Services" if charitynumber=="SC026243"
replace charityname = "Hope Church Coatbridge Free Church of Scotland" if charitynumber=="SC038275"
replace charityname = "Asociacion San Mateo" if charitynumber=="SC040481"
replace charityname = "Tenants Assoc Coatshill Thornhill Community Hall Management Committee" if charitynumber=="SC004540"
replace charityname = "Oban Youth Cafe Project" if charitynumber=="SC032354"
replace charityname = "Mactaggart Community Cyber Cafe" if charitynumber=="SC028306"
replace charityname = "The Royal Infirmary of Edinburgh Pelican Nurses' League" if charitynumber=="SC001049"
replace charityname = "Tain & District Youth Cafe YMCA" if charitynumber=="SC027164"
replace charityname = "Robert and Jeanne Mairs' Charitable Trust" if charitynumber=="SC033091"
replace charityname = "Cafe Philosophique Aberdeenshire" if charitynumber=="SC042534"
replace charityname = "Nature's Rights" if charitynumber=="SC045540"
replace charityname = "Let's Talk Menopause" if charitynumber=="SC045889"

capture drop orglowcl
gen orglowcl=lower(charityname)
replace orglowcl = subinstr(orglowcl,"!","",.)
replace orglowcl = subinstr(orglowcl,"#","",.)
replace orglowcl = subinstr(orglowcl,"%","",.)
replace orglowcl = subinstr(orglowcl,"&","",.)
replace orglowcl = subinstr(orglowcl,"'","",.)
replace orglowcl = subinstr(orglowcl,"(","",.)
replace orglowcl = subinstr(orglowcl,")","",.)
replace orglowcl = subinstr(orglowcl,"*","",.)
replace orglowcl = subinstr(orglowcl,"+","",.)
replace orglowcl = subinstr(orglowcl,",","",.)
replace orglowcl = subinstr(orglowcl,"-","",.)
replace orglowcl = subinstr(orglowcl,".","",.)
replace orglowcl = subinstr(orglowcl,"/","",.)
replace orglowcl = subinstr(orglowcl,":","",.)
replace orglowcl = subinstr(orglowcl,"=","",.)
replace orglowcl = subinstr(orglowcl,"?","",.)
replace orglowcl = subinstr(orglowcl,"@","",.)
replace orglowcl = subinstr(orglowcl,"[","",.)
replace orglowcl = subinstr(orglowcl,"\","",.)
replace orglowcl = subinstr(orglowcl,"]","",.)
replace orglowcl = subinstr(orglowcl,"_","",.)
replace orglowcl = subinstr(orglowcl,"`","",.)
replace orglowcl = subinstr(orglowcl,";","",.)
replace orglowcl = subinstr(orglowcl,"'","",.)
replace orglowcl = subinstr(orglowcl,"    "," ",.)
replace orglowcl = subinstr(orglowcl,"   "," ",.)
replace orglowcl = subinstr(orglowcl,"  "," ",.)
replace orglowcl = subinstr(orglowcl,"}"," ",.)
replace orglowcl = subinstr(orglowcl,"{"," ",.)
charlist orglowcl
save, replace

capture drop orgcheck
gen orgcheck=orglowcl
replace orgcheck = subinstr(orgcheck,"1","",.)
replace orgcheck = subinstr(orgcheck,"2","",.)
replace orgcheck = subinstr(orgcheck,"3","",.)
replace orgcheck = subinstr(orgcheck,"4","",.)
replace orgcheck = subinstr(orgcheck,"5","",.)
replace orgcheck = subinstr(orgcheck,"6","",.)
replace orgcheck = subinstr(orgcheck,"7","",.)
replace orgcheck = subinstr(orgcheck,"8","",.)
replace orgcheck = subinstr(orgcheck,"9","",.)
replace orgcheck = subinstr(orgcheck,"0","",.)
replace orgcheck = subinstr(orgcheck,"a","",.)
replace orgcheck = subinstr(orgcheck,"b","",.)
replace orgcheck = subinstr(orgcheck,"c","",.)
replace orgcheck = subinstr(orgcheck,"d","",.)
replace orgcheck = subinstr(orgcheck,"e","",.)
replace orgcheck = subinstr(orgcheck,"f","",.)
replace orgcheck = subinstr(orgcheck,"g","",.)
replace orgcheck = subinstr(orgcheck,"h","",.)
replace orgcheck = subinstr(orgcheck,"i","",.)
replace orgcheck = subinstr(orgcheck,"j","",.)
replace orgcheck = subinstr(orgcheck,"k","",.)
replace orgcheck = subinstr(orgcheck,"l","",.)
replace orgcheck = subinstr(orgcheck,"m","",.)
replace orgcheck = subinstr(orgcheck,"n","",.)
replace orgcheck = subinstr(orgcheck,"o","",.)
replace orgcheck = subinstr(orgcheck,"p","",.)
replace orgcheck = subinstr(orgcheck,"q","",.)
replace orgcheck = subinstr(orgcheck,"r","",.)
replace orgcheck = subinstr(orgcheck,"s","",.)
replace orgcheck = subinstr(orgcheck,"t","",.)
replace orgcheck = subinstr(orgcheck,"y","",.)
replace orgcheck = subinstr(orgcheck,"u","",.)
replace orgcheck = subinstr(orgcheck,"v","",.)
replace orgcheck = subinstr(orgcheck,"w","",.)
replace orgcheck = subinstr(orgcheck,"x","",.)
replace orgcheck = subinstr(orgcheck,"y","",.)
replace orgcheck = subinstr(orgcheck,"z","",.)
replace orgcheck = subinstr(orgcheck," ","",.)

charlist orgcheck
return list
browse charitynumber orgcheck charityname if orgcheck!=""
drop orgcheck
replace orglowcl=strtrim(orglowcl)

save, replace

********************************************************************************
***** Deterministic matching
********************************************************************************

**** match to milo and output according to match level
*** output those matching exactly on name and postcode
**** identify those that match exactly on name
merge m:m orglowcl using ///
"$wp1\MILO\milo_aims.dta" ///
, keepusing(orgname orgid owner* postcode LAD*)

drop if _merge<3
drop _merge
save "$wp1\oscr\oscrnmmatch.dta", replace

*** identify those that also matched by postcode
merge m:m orglowcl pcns using ///
"$wp1\MILO\milo_aims.dta" ///
, keepusing(owner*) update

drop if _merge<3
drop if pcns==""
drop _merge

contract charityname charitynumber oscr_postcode orgid orgname LAD* owner*
save "$wp1\oscr\oscrnmpc.dta", replace
export delimited using "$wp1\oscr\oscrnmpc.txt", delimiter(tab) replace

*** now name only

use "$wp1\oscr\oscrnmmatch.dta", clear
merge m:m charitynumber using ///
"$wp1\oscr\oscrnmpc.dta" ///
, keepusing(orgid)
drop if _merge==3
drop _merge
contract charityname charitynumber oscr_postcode orgname postcode orgid LAD* owner*
save "$wp1\oscr\oscrnmnotpc.dta", replace
format charityname orgname %50s
****browse orgname postcode charityname oscr_postcode 
export delimited using "$wp1\oscr\oscrnmnotpc.txt", delimiter(tab) replace

********************************************************************************
*****  Probabilistic matching
********************************************************************************
use "$wp1\oscr\oscrstillnotmilo.dta", clear
keep charitynumber charityname charitystatus principalofficetrusteesaddres ///
oscr_postcode constitutionalform
contract charitynumber charityname charitystatus ///
principalofficetrusteesaddres oscr_postcode constitutionalform
gen pc_dist=substr(oscr_postcode,1,(strpos(oscr_postcode," ")))
save "$wp1\oscr\oscrforfuzzy.dta", replace

stnd_compname charityname, gen(st_orgname) patpath("c:\ado\plus\p\")
save, replace

use "$wp1\MILO\milo_aims.dta", clear
replace charitynumber=regcharcln
merge m:1 charitynumber using "$wp1\oscr\oscrpublic.dta", keepusing(charityname)
drop if _merge>1
drop _merge
drop charityname
merge 1:1 orgid using "$wp1\oscr\oscrnmpc.dta", keepusing(charityname)
drop if _merge>1
drop _merge
drop charityname
merge 1:m orgid using "$wp1\oscr\oscrnmnotpc.dta", keepusing(charityname)
drop if _merge>1
drop _merge
drop charityname

keep orgname orgid street citycounty postcode orgtype regcharcl orglowcl owner*
contract orgname orgid street citycounty postcode orgtype regcharcl  ///
owner* orglowcl
gen pc_area=substr(postcode,1,(strpos(postcode," ")))

save "$wp1\MILO\fuzzymilo.dta", replace

stnd_compname orgname, gen(st_orgname) patpath("c:\ado\plus\p\")
save, replace

use "$wp1\oscr\oscrforfuzzy.dta", clear

capture generate idmaster=_n
reclink2 st_orgname pc_dist using "$wp1\MILO\fuzzymilo.dta", idmaster(idmaster) idusing(orgid) ///
gen(match2) wmatch(10 2) 
format charityname %50s
sort match
save "$wp1\oscr\fuzzymatched.dta", replace
**browse charityname oscr_postcode orgname postcode match if oscr_postcode==postcode & oscr_postcode!= ""

**browse charityname oscr_postcode orgname postcode match if oscr_postcode==postcode & pc3==Upc3

gen matched=1 if oscr_postcode!= "" & oscr_postcode==postcode

drop if _merge==1
drop _merge

**browse charityname oscr_postcode orgname postcode match if pc3==Upc3

gen pcoscr_sec=substr(oscr_postcode,1,(strpos(oscr_postcode," ")+1))
gen pcmilo_sec=substr(postcode,1,(strpos(postcode," ")+1))

**browse charityname oscr_postcode orgname postcode match if pcoscr_sec==pcmilo_sec
**browse charityname oscr_postcode orgname postcode match if pcoscr_sec==pcmilo_sec & match>=.97

replace matched=1 if pcoscr_sec==pcmilo_sec & match>=.97

**browse charityname oscr_postcode orgname postcode match if match>=.97

replace matched=1 if match>=.97

save,replace

***** this has identified the probable matches. The following added geographical ///
*** identifiers for SCVO to look at the file of potential dupes themselves

gen pcns=subinstr(oscr_postcode," ","",.)
charlist pcns
merge m:1 pcns using "$geog\ONSPDNOV15.dta" , ///
keepusing(gor oslaua) keep(match master) update
drop _merge
save, replace
tab gor
tab oslau

ren gor GOR10CD
merge m:1 GOR10CD using "$geog\gorlookup.dta", update 
replace GOR10NM= "Wales" if GOR10CD=="W99999999"
replace GOR10NM= "Scotland" if GOR10CD=="S99999999"
replace GOR10NM= "Northern Ireland" if GOR10CD=="N99999999"
replace GOR10NM= "Channel Islands" if GOR10CD=="L99999999"

drop _merge
replace GOR10NM="Z Not matched" if GOR10NM=="" & pcns>""
replace GOR10NM="ZZ Empty" if pcns==""
save, replace

rename oslau LAD15CD
merge m:1 LAD15CD using "$geog\lacodelookup2015.dta", update
replace LAD15NM="Z Out of Scotland" if substr(GOR10CD,1,1)=="E"
replace LAD15NM="Z Out of Scotland" if substr(GOR10CD,1,1)=="W"
replace LAD15NM="Z Out of Scotland" if substr(GOR10CD,1,1)=="N"
replace LAD15NM="Z Out of Scotland" if substr(GOR10CD,1,1)=="L"
replace LAD15NM="ZZ Not matched" if LAD15NM=="" & pcns>""
replace LAD15NM="ZZZ Empty" if pcns==""
drop _merge
save, replace
tab LAD15NM

keep if matched==1

save "$wp1\oscr\probablematches.dta", replace

capture drop maxmatch
bysort orgid: egen double maxmatch=max(match2)
drop if match2<maxmatch & maxmatch!=.
save, replace 

********************************************************************************
*****  Create combined file
********************************************************************************

use "$wp1\MILO\milo_aims.dta", clear
capture drop oscrhow
sort regcharcln
compress

save "$wp1\MILO\milo_merged.dta", replace
ren postcode milo_postcode
replace charitynumber=regcharcln if charitynumber==""
merge m:1 charitynumber using "$wp1\oscr\oscrpublic.dta", update replace
drop if _merge==2
replace charitynumber="" if _merge==1
gen oscrhow="1 regno" if _merge>1
drop if orgid==""
drop _merge
merge m:m orgid using "$wp1\oscr\oscrnmpc.dta", update 
drop if _merge==2
**browse if _merge==5
replace oscrhow="2 name & pc" if _merge>1 & oscrhow==""
drop _merge

merge m:m orgid using "$wp1\oscr\oscrnmnotpc.dta", update 
drop if _merge==2
**browse if _merge==5
replace oscrhow="3 name only" if _merge>1 & oscrhow==""
drop _merge
save, replace

bysort orgid: gen dupes=_N
tab dupes
**browse orgname milo_postcode regcharcln charityname charitynumber postcode oscrhow if dupes>1 
drop _freq
contract orgname orgid orgtype parentorg branchoflargerorganisation ///
largerorganisationdetails uniformedgroup street citycounty milo_postcode aims ///
ownertsi placeofworship numberoffulltimestaff areaofactivity noofvolunteers ///
neigbourhoodservedglasgowcity mainactivities registeredcharity regcharno ///
socialenterprise par_pcode par_aims par_mainacts par_regchar sc_num genchar ///
icnpo icnpohow synthsic07gp sic07 sic07gp sic07source charitynumber charityname ///
registereddate knownas charitystatus oscr_postcode constitutionalform ///
previousconstitutionalform1 geographicalspread mainoperatinglocation purposes ///
beneficiaries activities objectives principalofficetrusteesaddress website ///
mostrecentyearincome mostrecentyearexpenditure mailingcycle yearend ///
parentcharityname parentcharitynumber parentcharitycountryofregistrati ///
designatedreligiousbody regulatorytype regcharcln par_oname LAD15CD osward ///
oshlthau GOR10CD teclec lsoa11 ru11ind GOR10NM LAD15NM simd2012_sc_quintile ///
simd2012_sc_decile pcns oscrhow postcode

codebook orgid
drop _freq
compress
save, replace

merge 1:m orgid using "$wp1\oscr\probablematches.dta", update 
drop if _merge==2
replace oscrhow="4 probable" if _merge>1 & oscrhow==""

save, replace 

drop _merge
merge m:1 charitynumber using "$wp1\oscr\oscrpublic.dta", update replace
replace oscrhow="5 Milo only" if _merge==1
replace oscrhow="6 OSCR only" if _merge==2
save, replace
capture drop _freq match2 maxmatch _merge

gen combname=charityname
replace combname=orgname if combname==""
format combname %50s
gen lists=1 if oscrhow=="5 Milo only"
replace lists=2 if oscrhow=="6 OSCR only"
replace lists=3 if lists==.
label define LISTS ///
1 "Milo only" ///
2 "OSCR only" ///
3 "Milo & OSCR"

numlabel LISTS, add

label values lists LISTS

save, replace
